/**
 * ZapWork - OpenAPI 3.0
 * Send messages with ZapWork
 *
 * The version of the OpenAPI document: 1.0.11
 * Contact: suporte@multiplica.me
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import Message from '../model/Message';
import SendMessage200Response from '../model/SendMessage200Response';

/**
* Notifications service.
* @module api/NotificationsApi
* @version 1.0.11
*/
export default class NotificationsApi {

    /**
    * Constructs a new NotificationsApi. 
    * @alias module:api/NotificationsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Send a new message
     * Send a new message
     * @param {module:model/Message} message Send a new message
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/SendMessage200Response} and HTTP response
     */
    sendMessageWithHttpInfo(message) {
      let postBody = message;
      // verify the required parameter 'message' is set
      if (message === undefined || message === null) {
        throw new Error("Missing the required parameter 'message' when calling sendMessage");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = ['application/json', 'application/xml', 'application/x-www-form-urlencoded'];
      let accepts = ['application/json'];
      let returnType = SendMessage200Response;
      return this.apiClient.callApi(
        '/notificacoes', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Send a new message
     * Send a new message
     * @param {module:model/Message} message Send a new message
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/SendMessage200Response}
     */
    sendMessage(message) {
      return this.sendMessageWithHttpInfo(message)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
